diff --git a/gcc/config/i386/i386.c b/gcc/config/i386/i386.c
index 3bb2cab57a3..5d9cad7468b 100644
--- a/gcc/config/i386/i386.c
+++ b/gcc/config/i386/i386.c
@@ -1840,6 +1840,54 @@ init_cumulative_args (CUMULATIVE_ARGS *cum,  /* Argument info to initialize */
   cfun->machine->arg_reg_available = (cum->nregs > 0);
 }
 
+/* Return the single 64-bit vector type of TYPE.  */
+
+static const_tree
+single_m64_base_type (const_tree type)
+{
+  if ((TREE_CODE (type) == RECORD_TYPE
+       || TREE_CODE (type) == UNION_TYPE
+       || TREE_CODE (type) == QUAL_UNION_TYPE)
+      && int_size_in_bytes (type) == 8)
+    {
+      const_tree field;
+      const_tree first_field = nullptr;
+
+      for (field = TYPE_FIELDS (type);
+	   field;
+	   field = DECL_CHAIN (field))
+	if (TREE_CODE (field) == FIELD_DECL)
+	  {
+	    if (TREE_TYPE (field) == error_mark_node)
+	      continue;
+
+	    /* Skip if structure has more than one field.  */
+	    if (first_field)
+	      return nullptr;
+
+	    first_field = field;
+	  }
+
+      /* Skip if structure doesn't have any fields.  */
+      if (!first_field)
+	return nullptr;
+
+      type = TREE_TYPE (first_field);
+
+      /* Skip if structure size isn't 64 bits.  */
+      if (int_size_in_bytes (type) != 8)
+	return nullptr;
+
+      /* Return if a 64-bit vector is found.  */
+      if (TREE_CODE (type) == VECTOR_TYPE)
+	return type;
+
+      return single_m64_base_type (type);
+    }
+
+  return nullptr;
+}
+
 /* Return the "natural" mode for TYPE.  In most cases, this is just TYPE_MODE.
    But in the case of vector types, it is some vector mode.
 
@@ -1863,6 +1911,56 @@ type_natural_mode (const_tree type, const CUMULATIVE_ARGS *cum,
 {
   machine_mode mode = TYPE_MODE (type);
 
+  const_tree m64_type = single_m64_base_type (type);
+  if (m64_type)
+    {
+      mode = TYPE_MODE (m64_type);
+
+      int gcc_version = 0;
+      if (mode == V2SFmode)
+	{
+	  /* GCC 11 enables V2SFmode without TARGET_3DNOW.  */
+	  if (!TARGET_3DNOW)
+	    gcc_version = 11;
+	}
+      else
+	{
+	  /* GCC 10 enables other MMX modes without TARGET_MMX.  */
+	  if (!TARGET_MMX)
+	    gcc_version = 10;
+	}
+
+      if (gcc_version)
+	{
+	  if (in_return)
+	    {
+	      static bool warnedm64_ret;
+	      if (!warnedm64_ret)
+		{
+		  if (warning (OPT_Wpsabi,
+			       "the ABI of returning structure with a "
+			       "64-bit vector has changed in GCC %d.1",
+			       gcc_version))
+		    warnedm64_ret = true;
+		}
+	    }
+	  else
+	    {
+	      static bool warnedm64;
+	      if (!warnedm64)
+		{
+		  if (warning (OPT_Wpsabi,
+			       "the ABI of passing structure with a "
+			       "64-bit vector has changed in GCC %d.1",
+			       gcc_version))
+		    warnedm64 = true;
+		}
+	    }
+	}
+
+      return mode;
+    }
+
   if (TREE_CODE (type) == VECTOR_TYPE && !VECTOR_MODE_P (mode))
     {
       HOST_WIDE_INT size = int_size_in_bytes (type);
diff --git a/gcc/testsuite/gcc.target/i386/pr102027-1.c b/gcc/testsuite/gcc.target/i386/pr102027-1.c
new file mode 100644
index 00000000000..078ad8055e0
--- /dev/null
+++ b/gcc/testsuite/gcc.target/i386/pr102027-1.c
@@ -0,0 +1,15 @@
+/* { dg-do compile { target { ! ia32 } } } */
+/* { dg-options "-mno-3dnow" } */
+
+struct V2SF {
+  __attribute__((__vector_size__(2 * sizeof(float)))) float v;
+};
+extern struct V2SF x;
+extern void foo (struct V2SF);
+
+struct V2SF
+bar (void)
+{ /* { dg-warning "the ABI of returning structure with a 64-bit vector has changed in GCC 11.1" } */
+  foo (x); /* { dg-warning "the ABI of passing structure with a 64-bit vector has changed in GCC 11.1" } */
+  return x;
+}
diff --git a/gcc/testsuite/gcc.target/i386/pr102027-2.c b/gcc/testsuite/gcc.target/i386/pr102027-2.c
new file mode 100644
index 00000000000..ed48c238665
--- /dev/null
+++ b/gcc/testsuite/gcc.target/i386/pr102027-2.c
@@ -0,0 +1,15 @@
+/* { dg-do compile { target { ! ia32 } } } */
+/* { dg-options "-mno-3dnow" } */
+
+union U2SF {
+  __attribute__((__vector_size__(2 * sizeof(float)))) float v;
+};
+extern union U2SF x;
+extern void foo (union U2SF);
+
+union U2SF
+bar (void)
+{ /* { dg-warning "the ABI of returning structure with a 64-bit vector has changed in GCC 11.1" } */
+  foo (x); /* { dg-warning "the ABI of passing structure with a 64-bit vector has changed in GCC 11.1" } */
+  return x;
+}
diff --git a/gcc/testsuite/gcc.target/i386/pr102027-3.c b/gcc/testsuite/gcc.target/i386/pr102027-3.c
new file mode 100644
index 00000000000..e41b8b73f98
--- /dev/null
+++ b/gcc/testsuite/gcc.target/i386/pr102027-3.c
@@ -0,0 +1,17 @@
+/* { dg-do compile { target { ! ia32 } } } */
+/* { dg-options "-mno-3dnow" } */
+
+struct V2SF1 {
+  __attribute__((__vector_size__(2 * sizeof(float)))) float v;
+};
+struct V2SF {
+  struct V2SF1 x;
+};
+extern struct V2SF x;
+extern void foo (struct V2SF);
+
+void
+bar (void)
+{
+  foo (x); /* { dg-warning "the ABI of passing structure with a 64-bit vector has changed in GCC 11.1" } */
+}
diff --git a/gcc/testsuite/gcc.target/i386/pr102105-1.c b/gcc/testsuite/gcc.target/i386/pr102105-1.c
new file mode 100644
index 00000000000..ec151a6e826
--- /dev/null
+++ b/gcc/testsuite/gcc.target/i386/pr102105-1.c
@@ -0,0 +1,15 @@
+/* { dg-do compile { target { ! ia32 } } } */
+/* { dg-options "-mno-mmx" } */
+
+struct V8QI {
+  __attribute__((__vector_size__(8))) char v;
+};
+extern struct V8QI x;
+extern void foo (struct V8QI);
+
+struct V8QI
+bar (void)
+{ /* { dg-warning "the ABI of returning structure with a 64-bit vector has changed in GCC 10.1" } */
+  foo (x); /* { dg-warning "the ABI of passing structure with a 64-bit vector has changed in GCC 10.1" } */
+  return x;
+}
diff --git a/gcc/testsuite/gcc.target/i386/pr102105-2.c b/gcc/testsuite/gcc.target/i386/pr102105-2.c
new file mode 100644
index 00000000000..47dc7e37791
--- /dev/null
+++ b/gcc/testsuite/gcc.target/i386/pr102105-2.c
@@ -0,0 +1,15 @@
+/* { dg-do compile { target { ! ia32 } } } */
+/* { dg-options "-mno-mmx" } */
+
+union U8QI {
+  __attribute__((__vector_size__(8))) char v;
+};
+extern union U8QI x;
+extern void foo (union U8QI);
+
+union U8QI
+bar (void)
+{ /* { dg-warning "the ABI of returning structure with a 64-bit vector has changed in GCC 10.1" } */
+  foo (x); /* { dg-warning "the ABI of passing structure with a 64-bit vector has changed in GCC 10.1" } */
+  return x;
+}
diff --git a/gcc/testsuite/gcc.target/i386/pr102105-3.c b/gcc/testsuite/gcc.target/i386/pr102105-3.c
new file mode 100644
index 00000000000..45bb4ba493a
--- /dev/null
+++ b/gcc/testsuite/gcc.target/i386/pr102105-3.c
@@ -0,0 +1,17 @@
+/* { dg-do compile { target { ! ia32 } } } */
+/* { dg-options "-mno-mmx" } */
+
+struct V8QI1 {
+  __attribute__((__vector_size__(8))) char v;
+};
+struct V8QI {
+  struct V8QI1 x;
+};
+extern struct V8QI x;
+extern void foo (struct V8QI);
+
+void
+bar (void)
+{
+  foo (x); /* { dg-warning "the ABI of passing structure with a 64-bit vector has changed in GCC 10.1" } */
+}
diff --git a/gcc/testsuite/gcc.target/i386/pr102105-4.c b/gcc/testsuite/gcc.target/i386/pr102105-4.c
new file mode 100644
index 00000000000..763d51ccf0b
--- /dev/null
+++ b/gcc/testsuite/gcc.target/i386/pr102105-4.c
@@ -0,0 +1,17 @@
+/* { dg-do compile { target { ! ia32 } } } */
+/* { dg-options "-mno-mmx" } */
+
+struct v1di
+{
+  __attribute__((__vector_size__(8))) long long ll;
+};
+extern struct v1di x;
+
+extern void foo (struct v1di);
+
+struct v1di
+bar (void)
+{ /* { dg-warning "the ABI of returning structure with a 64-bit vector has changed in GCC 10.1" } */
+  foo (x); /* { dg-warning "the ABI of passing structure with a 64-bit vector has changed in GCC 10.1" } */
+  return x;
+}
diff --git a/gcc/testsuite/gcc.target/i386/sse2-mmx-4.c b/gcc/testsuite/gcc.target/i386/sse2-mmx-4.c
index d923724fc1c..01ee8db4a4a 100644
--- a/gcc/testsuite/gcc.target/i386/sse2-mmx-4.c
+++ b/gcc/testsuite/gcc.target/i386/sse2-mmx-4.c
@@ -1,4 +1,4 @@
 /* { dg-do run { target { ! ia32 } } } */
-/* { dg-options "-O2 -msse2 -mno-mmx" } */
+/* { dg-options "-O2 -msse2 -mno-mmx -Wno-psabi" } */
 
 #include "mmx-4.c"